// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: essmodule/essmodule.proto

package openfmb.essmodule;

/**
 * <pre>
 * MISSING DOCUMENTATION!!!
 * </pre>
 *
 * Protobuf type {@code essmodule.ESSCapabilityRatings}
 */
public final class ESSCapabilityRatings extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:essmodule.ESSCapabilityRatings)
    ESSCapabilityRatingsOrBuilder {
private static final long serialVersionUID = 0L;
  // Use ESSCapabilityRatings.newBuilder() to construct.
  private ESSCapabilityRatings(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private ESSCapabilityRatings() {
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new ESSCapabilityRatings();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.essmodule.Essmodule.internal_static_essmodule_ESSCapabilityRatings_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.essmodule.Essmodule.internal_static_essmodule_ESSCapabilityRatings_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.essmodule.ESSCapabilityRatings.class, openfmb.essmodule.ESSCapabilityRatings.Builder.class);
  }

  public static final int SOURCECAPABILITYRATINGS_FIELD_NUMBER = 1;
  private openfmb.commonmodule.SourceCapabilityRatings sourceCapabilityRatings_;
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.SourceCapabilityRatings sourceCapabilityRatings = 1 [(.uml.option_parent_message) = true];</code>
   * @return Whether the sourceCapabilityRatings field is set.
   */
  @java.lang.Override
  public boolean hasSourceCapabilityRatings() {
    return sourceCapabilityRatings_ != null;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.SourceCapabilityRatings sourceCapabilityRatings = 1 [(.uml.option_parent_message) = true];</code>
   * @return The sourceCapabilityRatings.
   */
  @java.lang.Override
  public openfmb.commonmodule.SourceCapabilityRatings getSourceCapabilityRatings() {
    return sourceCapabilityRatings_ == null ? openfmb.commonmodule.SourceCapabilityRatings.getDefaultInstance() : sourceCapabilityRatings_;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.SourceCapabilityRatings sourceCapabilityRatings = 1 [(.uml.option_parent_message) = true];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.SourceCapabilityRatingsOrBuilder getSourceCapabilityRatingsOrBuilder() {
    return sourceCapabilityRatings_ == null ? openfmb.commonmodule.SourceCapabilityRatings.getDefaultInstance() : sourceCapabilityRatings_;
  }

  public static final int VACHARTEMAXRTG_FIELD_NUMBER = 2;
  private openfmb.commonmodule.ASG vAChaRteMaxRtg_;
  /**
   * <pre>
   * Apparent Power Charge Maximum Rating
   * </pre>
   *
   * <code>.commonmodule.ASG VAChaRteMaxRtg = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return Whether the vAChaRteMaxRtg field is set.
   */
  @java.lang.Override
  public boolean hasVAChaRteMaxRtg() {
    return vAChaRteMaxRtg_ != null;
  }
  /**
   * <pre>
   * Apparent Power Charge Maximum Rating
   * </pre>
   *
   * <code>.commonmodule.ASG VAChaRteMaxRtg = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The vAChaRteMaxRtg.
   */
  @java.lang.Override
  public openfmb.commonmodule.ASG getVAChaRteMaxRtg() {
    return vAChaRteMaxRtg_ == null ? openfmb.commonmodule.ASG.getDefaultInstance() : vAChaRteMaxRtg_;
  }
  /**
   * <pre>
   * Apparent Power Charge Maximum Rating
   * </pre>
   *
   * <code>.commonmodule.ASG VAChaRteMaxRtg = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.ASGOrBuilder getVAChaRteMaxRtgOrBuilder() {
    return vAChaRteMaxRtg_ == null ? openfmb.commonmodule.ASG.getDefaultInstance() : vAChaRteMaxRtg_;
  }

  public static final int VADISCHARTEMAXRTG_FIELD_NUMBER = 3;
  private openfmb.commonmodule.ASG vADisChaRteMaxRtg_;
  /**
   * <pre>
   * Apparent Power Discharge Maximum Rating
   * </pre>
   *
   * <code>.commonmodule.ASG VADisChaRteMaxRtg = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return Whether the vADisChaRteMaxRtg field is set.
   */
  @java.lang.Override
  public boolean hasVADisChaRteMaxRtg() {
    return vADisChaRteMaxRtg_ != null;
  }
  /**
   * <pre>
   * Apparent Power Discharge Maximum Rating
   * </pre>
   *
   * <code>.commonmodule.ASG VADisChaRteMaxRtg = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The vADisChaRteMaxRtg.
   */
  @java.lang.Override
  public openfmb.commonmodule.ASG getVADisChaRteMaxRtg() {
    return vADisChaRteMaxRtg_ == null ? openfmb.commonmodule.ASG.getDefaultInstance() : vADisChaRteMaxRtg_;
  }
  /**
   * <pre>
   * Apparent Power Discharge Maximum Rating
   * </pre>
   *
   * <code>.commonmodule.ASG VADisChaRteMaxRtg = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.ASGOrBuilder getVADisChaRteMaxRtgOrBuilder() {
    return vADisChaRteMaxRtg_ == null ? openfmb.commonmodule.ASG.getDefaultInstance() : vADisChaRteMaxRtg_;
  }

  public static final int WCHARTEMAXRTG_FIELD_NUMBER = 4;
  private openfmb.commonmodule.ASG wChaRteMaxRtg_;
  /**
   * <pre>
   * Active Power Charge Maximum Rating
   * </pre>
   *
   * <code>.commonmodule.ASG WChaRteMaxRtg = 4 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return Whether the wChaRteMaxRtg field is set.
   */
  @java.lang.Override
  public boolean hasWChaRteMaxRtg() {
    return wChaRteMaxRtg_ != null;
  }
  /**
   * <pre>
   * Active Power Charge Maximum Rating
   * </pre>
   *
   * <code>.commonmodule.ASG WChaRteMaxRtg = 4 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The wChaRteMaxRtg.
   */
  @java.lang.Override
  public openfmb.commonmodule.ASG getWChaRteMaxRtg() {
    return wChaRteMaxRtg_ == null ? openfmb.commonmodule.ASG.getDefaultInstance() : wChaRteMaxRtg_;
  }
  /**
   * <pre>
   * Active Power Charge Maximum Rating
   * </pre>
   *
   * <code>.commonmodule.ASG WChaRteMaxRtg = 4 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.ASGOrBuilder getWChaRteMaxRtgOrBuilder() {
    return wChaRteMaxRtg_ == null ? openfmb.commonmodule.ASG.getDefaultInstance() : wChaRteMaxRtg_;
  }

  public static final int WDISCHARTEMAXRTG_FIELD_NUMBER = 5;
  private openfmb.commonmodule.ASG wDisChaRteMaxRtg_;
  /**
   * <pre>
   * Active Power Discharge Maximum Rating
   * </pre>
   *
   * <code>.commonmodule.ASG WDisChaRteMaxRtg = 5 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return Whether the wDisChaRteMaxRtg field is set.
   */
  @java.lang.Override
  public boolean hasWDisChaRteMaxRtg() {
    return wDisChaRteMaxRtg_ != null;
  }
  /**
   * <pre>
   * Active Power Discharge Maximum Rating
   * </pre>
   *
   * <code>.commonmodule.ASG WDisChaRteMaxRtg = 5 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The wDisChaRteMaxRtg.
   */
  @java.lang.Override
  public openfmb.commonmodule.ASG getWDisChaRteMaxRtg() {
    return wDisChaRteMaxRtg_ == null ? openfmb.commonmodule.ASG.getDefaultInstance() : wDisChaRteMaxRtg_;
  }
  /**
   * <pre>
   * Active Power Discharge Maximum Rating
   * </pre>
   *
   * <code>.commonmodule.ASG WDisChaRteMaxRtg = 5 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.ASGOrBuilder getWDisChaRteMaxRtgOrBuilder() {
    return wDisChaRteMaxRtg_ == null ? openfmb.commonmodule.ASG.getDefaultInstance() : wDisChaRteMaxRtg_;
  }

  public static final int WHRTG_FIELD_NUMBER = 6;
  private openfmb.commonmodule.ASG wHRtg_;
  /**
   * <pre>
   * Energy rating of the DER storage.
   * </pre>
   *
   * <code>.commonmodule.ASG WHRtg = 6 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return Whether the wHRtg field is set.
   */
  @java.lang.Override
  public boolean hasWHRtg() {
    return wHRtg_ != null;
  }
  /**
   * <pre>
   * Energy rating of the DER storage.
   * </pre>
   *
   * <code>.commonmodule.ASG WHRtg = 6 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The wHRtg.
   */
  @java.lang.Override
  public openfmb.commonmodule.ASG getWHRtg() {
    return wHRtg_ == null ? openfmb.commonmodule.ASG.getDefaultInstance() : wHRtg_;
  }
  /**
   * <pre>
   * Energy rating of the DER storage.
   * </pre>
   *
   * <code>.commonmodule.ASG WHRtg = 6 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.ASGOrBuilder getWHRtgOrBuilder() {
    return wHRtg_ == null ? openfmb.commonmodule.ASG.getDefaultInstance() : wHRtg_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (sourceCapabilityRatings_ != null) {
      output.writeMessage(1, getSourceCapabilityRatings());
    }
    if (vAChaRteMaxRtg_ != null) {
      output.writeMessage(2, getVAChaRteMaxRtg());
    }
    if (vADisChaRteMaxRtg_ != null) {
      output.writeMessage(3, getVADisChaRteMaxRtg());
    }
    if (wChaRteMaxRtg_ != null) {
      output.writeMessage(4, getWChaRteMaxRtg());
    }
    if (wDisChaRteMaxRtg_ != null) {
      output.writeMessage(5, getWDisChaRteMaxRtg());
    }
    if (wHRtg_ != null) {
      output.writeMessage(6, getWHRtg());
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (sourceCapabilityRatings_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getSourceCapabilityRatings());
    }
    if (vAChaRteMaxRtg_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(2, getVAChaRteMaxRtg());
    }
    if (vADisChaRteMaxRtg_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(3, getVADisChaRteMaxRtg());
    }
    if (wChaRteMaxRtg_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(4, getWChaRteMaxRtg());
    }
    if (wDisChaRteMaxRtg_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(5, getWDisChaRteMaxRtg());
    }
    if (wHRtg_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(6, getWHRtg());
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.essmodule.ESSCapabilityRatings)) {
      return super.equals(obj);
    }
    openfmb.essmodule.ESSCapabilityRatings other = (openfmb.essmodule.ESSCapabilityRatings) obj;

    if (hasSourceCapabilityRatings() != other.hasSourceCapabilityRatings()) return false;
    if (hasSourceCapabilityRatings()) {
      if (!getSourceCapabilityRatings()
          .equals(other.getSourceCapabilityRatings())) return false;
    }
    if (hasVAChaRteMaxRtg() != other.hasVAChaRteMaxRtg()) return false;
    if (hasVAChaRteMaxRtg()) {
      if (!getVAChaRteMaxRtg()
          .equals(other.getVAChaRteMaxRtg())) return false;
    }
    if (hasVADisChaRteMaxRtg() != other.hasVADisChaRteMaxRtg()) return false;
    if (hasVADisChaRteMaxRtg()) {
      if (!getVADisChaRteMaxRtg()
          .equals(other.getVADisChaRteMaxRtg())) return false;
    }
    if (hasWChaRteMaxRtg() != other.hasWChaRteMaxRtg()) return false;
    if (hasWChaRteMaxRtg()) {
      if (!getWChaRteMaxRtg()
          .equals(other.getWChaRteMaxRtg())) return false;
    }
    if (hasWDisChaRteMaxRtg() != other.hasWDisChaRteMaxRtg()) return false;
    if (hasWDisChaRteMaxRtg()) {
      if (!getWDisChaRteMaxRtg()
          .equals(other.getWDisChaRteMaxRtg())) return false;
    }
    if (hasWHRtg() != other.hasWHRtg()) return false;
    if (hasWHRtg()) {
      if (!getWHRtg()
          .equals(other.getWHRtg())) return false;
    }
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasSourceCapabilityRatings()) {
      hash = (37 * hash) + SOURCECAPABILITYRATINGS_FIELD_NUMBER;
      hash = (53 * hash) + getSourceCapabilityRatings().hashCode();
    }
    if (hasVAChaRteMaxRtg()) {
      hash = (37 * hash) + VACHARTEMAXRTG_FIELD_NUMBER;
      hash = (53 * hash) + getVAChaRteMaxRtg().hashCode();
    }
    if (hasVADisChaRteMaxRtg()) {
      hash = (37 * hash) + VADISCHARTEMAXRTG_FIELD_NUMBER;
      hash = (53 * hash) + getVADisChaRteMaxRtg().hashCode();
    }
    if (hasWChaRteMaxRtg()) {
      hash = (37 * hash) + WCHARTEMAXRTG_FIELD_NUMBER;
      hash = (53 * hash) + getWChaRteMaxRtg().hashCode();
    }
    if (hasWDisChaRteMaxRtg()) {
      hash = (37 * hash) + WDISCHARTEMAXRTG_FIELD_NUMBER;
      hash = (53 * hash) + getWDisChaRteMaxRtg().hashCode();
    }
    if (hasWHRtg()) {
      hash = (37 * hash) + WHRTG_FIELD_NUMBER;
      hash = (53 * hash) + getWHRtg().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.essmodule.ESSCapabilityRatings parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.essmodule.ESSCapabilityRatings parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.essmodule.ESSCapabilityRatings parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.essmodule.ESSCapabilityRatings parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.essmodule.ESSCapabilityRatings parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.essmodule.ESSCapabilityRatings parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.essmodule.ESSCapabilityRatings parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.essmodule.ESSCapabilityRatings parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.essmodule.ESSCapabilityRatings parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.essmodule.ESSCapabilityRatings parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.essmodule.ESSCapabilityRatings parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.essmodule.ESSCapabilityRatings parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.essmodule.ESSCapabilityRatings prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * MISSING DOCUMENTATION!!!
   * </pre>
   *
   * Protobuf type {@code essmodule.ESSCapabilityRatings}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:essmodule.ESSCapabilityRatings)
      openfmb.essmodule.ESSCapabilityRatingsOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.essmodule.Essmodule.internal_static_essmodule_ESSCapabilityRatings_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.essmodule.Essmodule.internal_static_essmodule_ESSCapabilityRatings_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.essmodule.ESSCapabilityRatings.class, openfmb.essmodule.ESSCapabilityRatings.Builder.class);
    }

    // Construct using openfmb.essmodule.ESSCapabilityRatings.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      sourceCapabilityRatings_ = null;
      if (sourceCapabilityRatingsBuilder_ != null) {
        sourceCapabilityRatingsBuilder_.dispose();
        sourceCapabilityRatingsBuilder_ = null;
      }
      vAChaRteMaxRtg_ = null;
      if (vAChaRteMaxRtgBuilder_ != null) {
        vAChaRteMaxRtgBuilder_.dispose();
        vAChaRteMaxRtgBuilder_ = null;
      }
      vADisChaRteMaxRtg_ = null;
      if (vADisChaRteMaxRtgBuilder_ != null) {
        vADisChaRteMaxRtgBuilder_.dispose();
        vADisChaRteMaxRtgBuilder_ = null;
      }
      wChaRteMaxRtg_ = null;
      if (wChaRteMaxRtgBuilder_ != null) {
        wChaRteMaxRtgBuilder_.dispose();
        wChaRteMaxRtgBuilder_ = null;
      }
      wDisChaRteMaxRtg_ = null;
      if (wDisChaRteMaxRtgBuilder_ != null) {
        wDisChaRteMaxRtgBuilder_.dispose();
        wDisChaRteMaxRtgBuilder_ = null;
      }
      wHRtg_ = null;
      if (wHRtgBuilder_ != null) {
        wHRtgBuilder_.dispose();
        wHRtgBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.essmodule.Essmodule.internal_static_essmodule_ESSCapabilityRatings_descriptor;
    }

    @java.lang.Override
    public openfmb.essmodule.ESSCapabilityRatings getDefaultInstanceForType() {
      return openfmb.essmodule.ESSCapabilityRatings.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.essmodule.ESSCapabilityRatings build() {
      openfmb.essmodule.ESSCapabilityRatings result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.essmodule.ESSCapabilityRatings buildPartial() {
      openfmb.essmodule.ESSCapabilityRatings result = new openfmb.essmodule.ESSCapabilityRatings(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(openfmb.essmodule.ESSCapabilityRatings result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.sourceCapabilityRatings_ = sourceCapabilityRatingsBuilder_ == null
            ? sourceCapabilityRatings_
            : sourceCapabilityRatingsBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.vAChaRteMaxRtg_ = vAChaRteMaxRtgBuilder_ == null
            ? vAChaRteMaxRtg_
            : vAChaRteMaxRtgBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000004) != 0)) {
        result.vADisChaRteMaxRtg_ = vADisChaRteMaxRtgBuilder_ == null
            ? vADisChaRteMaxRtg_
            : vADisChaRteMaxRtgBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000008) != 0)) {
        result.wChaRteMaxRtg_ = wChaRteMaxRtgBuilder_ == null
            ? wChaRteMaxRtg_
            : wChaRteMaxRtgBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000010) != 0)) {
        result.wDisChaRteMaxRtg_ = wDisChaRteMaxRtgBuilder_ == null
            ? wDisChaRteMaxRtg_
            : wDisChaRteMaxRtgBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000020) != 0)) {
        result.wHRtg_ = wHRtgBuilder_ == null
            ? wHRtg_
            : wHRtgBuilder_.build();
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.essmodule.ESSCapabilityRatings) {
        return mergeFrom((openfmb.essmodule.ESSCapabilityRatings)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.essmodule.ESSCapabilityRatings other) {
      if (other == openfmb.essmodule.ESSCapabilityRatings.getDefaultInstance()) return this;
      if (other.hasSourceCapabilityRatings()) {
        mergeSourceCapabilityRatings(other.getSourceCapabilityRatings());
      }
      if (other.hasVAChaRteMaxRtg()) {
        mergeVAChaRteMaxRtg(other.getVAChaRteMaxRtg());
      }
      if (other.hasVADisChaRteMaxRtg()) {
        mergeVADisChaRteMaxRtg(other.getVADisChaRteMaxRtg());
      }
      if (other.hasWChaRteMaxRtg()) {
        mergeWChaRteMaxRtg(other.getWChaRteMaxRtg());
      }
      if (other.hasWDisChaRteMaxRtg()) {
        mergeWDisChaRteMaxRtg(other.getWDisChaRteMaxRtg());
      }
      if (other.hasWHRtg()) {
        mergeWHRtg(other.getWHRtg());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              input.readMessage(
                  getSourceCapabilityRatingsFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000001;
              break;
            } // case 10
            case 18: {
              input.readMessage(
                  getVAChaRteMaxRtgFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000002;
              break;
            } // case 18
            case 26: {
              input.readMessage(
                  getVADisChaRteMaxRtgFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000004;
              break;
            } // case 26
            case 34: {
              input.readMessage(
                  getWChaRteMaxRtgFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000008;
              break;
            } // case 34
            case 42: {
              input.readMessage(
                  getWDisChaRteMaxRtgFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000010;
              break;
            } // case 42
            case 50: {
              input.readMessage(
                  getWHRtgFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000020;
              break;
            } // case 50
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private openfmb.commonmodule.SourceCapabilityRatings sourceCapabilityRatings_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.SourceCapabilityRatings, openfmb.commonmodule.SourceCapabilityRatings.Builder, openfmb.commonmodule.SourceCapabilityRatingsOrBuilder> sourceCapabilityRatingsBuilder_;
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.SourceCapabilityRatings sourceCapabilityRatings = 1 [(.uml.option_parent_message) = true];</code>
     * @return Whether the sourceCapabilityRatings field is set.
     */
    public boolean hasSourceCapabilityRatings() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.SourceCapabilityRatings sourceCapabilityRatings = 1 [(.uml.option_parent_message) = true];</code>
     * @return The sourceCapabilityRatings.
     */
    public openfmb.commonmodule.SourceCapabilityRatings getSourceCapabilityRatings() {
      if (sourceCapabilityRatingsBuilder_ == null) {
        return sourceCapabilityRatings_ == null ? openfmb.commonmodule.SourceCapabilityRatings.getDefaultInstance() : sourceCapabilityRatings_;
      } else {
        return sourceCapabilityRatingsBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.SourceCapabilityRatings sourceCapabilityRatings = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setSourceCapabilityRatings(openfmb.commonmodule.SourceCapabilityRatings value) {
      if (sourceCapabilityRatingsBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        sourceCapabilityRatings_ = value;
      } else {
        sourceCapabilityRatingsBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.SourceCapabilityRatings sourceCapabilityRatings = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setSourceCapabilityRatings(
        openfmb.commonmodule.SourceCapabilityRatings.Builder builderForValue) {
      if (sourceCapabilityRatingsBuilder_ == null) {
        sourceCapabilityRatings_ = builderForValue.build();
      } else {
        sourceCapabilityRatingsBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.SourceCapabilityRatings sourceCapabilityRatings = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder mergeSourceCapabilityRatings(openfmb.commonmodule.SourceCapabilityRatings value) {
      if (sourceCapabilityRatingsBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0) &&
          sourceCapabilityRatings_ != null &&
          sourceCapabilityRatings_ != openfmb.commonmodule.SourceCapabilityRatings.getDefaultInstance()) {
          getSourceCapabilityRatingsBuilder().mergeFrom(value);
        } else {
          sourceCapabilityRatings_ = value;
        }
      } else {
        sourceCapabilityRatingsBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.SourceCapabilityRatings sourceCapabilityRatings = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder clearSourceCapabilityRatings() {
      bitField0_ = (bitField0_ & ~0x00000001);
      sourceCapabilityRatings_ = null;
      if (sourceCapabilityRatingsBuilder_ != null) {
        sourceCapabilityRatingsBuilder_.dispose();
        sourceCapabilityRatingsBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.SourceCapabilityRatings sourceCapabilityRatings = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.SourceCapabilityRatings.Builder getSourceCapabilityRatingsBuilder() {
      bitField0_ |= 0x00000001;
      onChanged();
      return getSourceCapabilityRatingsFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.SourceCapabilityRatings sourceCapabilityRatings = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.SourceCapabilityRatingsOrBuilder getSourceCapabilityRatingsOrBuilder() {
      if (sourceCapabilityRatingsBuilder_ != null) {
        return sourceCapabilityRatingsBuilder_.getMessageOrBuilder();
      } else {
        return sourceCapabilityRatings_ == null ?
            openfmb.commonmodule.SourceCapabilityRatings.getDefaultInstance() : sourceCapabilityRatings_;
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.SourceCapabilityRatings sourceCapabilityRatings = 1 [(.uml.option_parent_message) = true];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.SourceCapabilityRatings, openfmb.commonmodule.SourceCapabilityRatings.Builder, openfmb.commonmodule.SourceCapabilityRatingsOrBuilder> 
        getSourceCapabilityRatingsFieldBuilder() {
      if (sourceCapabilityRatingsBuilder_ == null) {
        sourceCapabilityRatingsBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.SourceCapabilityRatings, openfmb.commonmodule.SourceCapabilityRatings.Builder, openfmb.commonmodule.SourceCapabilityRatingsOrBuilder>(
                getSourceCapabilityRatings(),
                getParentForChildren(),
                isClean());
        sourceCapabilityRatings_ = null;
      }
      return sourceCapabilityRatingsBuilder_;
    }

    private openfmb.commonmodule.ASG vAChaRteMaxRtg_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ASG, openfmb.commonmodule.ASG.Builder, openfmb.commonmodule.ASGOrBuilder> vAChaRteMaxRtgBuilder_;
    /**
     * <pre>
     * Apparent Power Charge Maximum Rating
     * </pre>
     *
     * <code>.commonmodule.ASG VAChaRteMaxRtg = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return Whether the vAChaRteMaxRtg field is set.
     */
    public boolean hasVAChaRteMaxRtg() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <pre>
     * Apparent Power Charge Maximum Rating
     * </pre>
     *
     * <code>.commonmodule.ASG VAChaRteMaxRtg = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return The vAChaRteMaxRtg.
     */
    public openfmb.commonmodule.ASG getVAChaRteMaxRtg() {
      if (vAChaRteMaxRtgBuilder_ == null) {
        return vAChaRteMaxRtg_ == null ? openfmb.commonmodule.ASG.getDefaultInstance() : vAChaRteMaxRtg_;
      } else {
        return vAChaRteMaxRtgBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Apparent Power Charge Maximum Rating
     * </pre>
     *
     * <code>.commonmodule.ASG VAChaRteMaxRtg = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setVAChaRteMaxRtg(openfmb.commonmodule.ASG value) {
      if (vAChaRteMaxRtgBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        vAChaRteMaxRtg_ = value;
      } else {
        vAChaRteMaxRtgBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Apparent Power Charge Maximum Rating
     * </pre>
     *
     * <code>.commonmodule.ASG VAChaRteMaxRtg = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setVAChaRteMaxRtg(
        openfmb.commonmodule.ASG.Builder builderForValue) {
      if (vAChaRteMaxRtgBuilder_ == null) {
        vAChaRteMaxRtg_ = builderForValue.build();
      } else {
        vAChaRteMaxRtgBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Apparent Power Charge Maximum Rating
     * </pre>
     *
     * <code>.commonmodule.ASG VAChaRteMaxRtg = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder mergeVAChaRteMaxRtg(openfmb.commonmodule.ASG value) {
      if (vAChaRteMaxRtgBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0) &&
          vAChaRteMaxRtg_ != null &&
          vAChaRteMaxRtg_ != openfmb.commonmodule.ASG.getDefaultInstance()) {
          getVAChaRteMaxRtgBuilder().mergeFrom(value);
        } else {
          vAChaRteMaxRtg_ = value;
        }
      } else {
        vAChaRteMaxRtgBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Apparent Power Charge Maximum Rating
     * </pre>
     *
     * <code>.commonmodule.ASG VAChaRteMaxRtg = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder clearVAChaRteMaxRtg() {
      bitField0_ = (bitField0_ & ~0x00000002);
      vAChaRteMaxRtg_ = null;
      if (vAChaRteMaxRtgBuilder_ != null) {
        vAChaRteMaxRtgBuilder_.dispose();
        vAChaRteMaxRtgBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Apparent Power Charge Maximum Rating
     * </pre>
     *
     * <code>.commonmodule.ASG VAChaRteMaxRtg = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.commonmodule.ASG.Builder getVAChaRteMaxRtgBuilder() {
      bitField0_ |= 0x00000002;
      onChanged();
      return getVAChaRteMaxRtgFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Apparent Power Charge Maximum Rating
     * </pre>
     *
     * <code>.commonmodule.ASG VAChaRteMaxRtg = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.commonmodule.ASGOrBuilder getVAChaRteMaxRtgOrBuilder() {
      if (vAChaRteMaxRtgBuilder_ != null) {
        return vAChaRteMaxRtgBuilder_.getMessageOrBuilder();
      } else {
        return vAChaRteMaxRtg_ == null ?
            openfmb.commonmodule.ASG.getDefaultInstance() : vAChaRteMaxRtg_;
      }
    }
    /**
     * <pre>
     * Apparent Power Charge Maximum Rating
     * </pre>
     *
     * <code>.commonmodule.ASG VAChaRteMaxRtg = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ASG, openfmb.commonmodule.ASG.Builder, openfmb.commonmodule.ASGOrBuilder> 
        getVAChaRteMaxRtgFieldBuilder() {
      if (vAChaRteMaxRtgBuilder_ == null) {
        vAChaRteMaxRtgBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.ASG, openfmb.commonmodule.ASG.Builder, openfmb.commonmodule.ASGOrBuilder>(
                getVAChaRteMaxRtg(),
                getParentForChildren(),
                isClean());
        vAChaRteMaxRtg_ = null;
      }
      return vAChaRteMaxRtgBuilder_;
    }

    private openfmb.commonmodule.ASG vADisChaRteMaxRtg_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ASG, openfmb.commonmodule.ASG.Builder, openfmb.commonmodule.ASGOrBuilder> vADisChaRteMaxRtgBuilder_;
    /**
     * <pre>
     * Apparent Power Discharge Maximum Rating
     * </pre>
     *
     * <code>.commonmodule.ASG VADisChaRteMaxRtg = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return Whether the vADisChaRteMaxRtg field is set.
     */
    public boolean hasVADisChaRteMaxRtg() {
      return ((bitField0_ & 0x00000004) != 0);
    }
    /**
     * <pre>
     * Apparent Power Discharge Maximum Rating
     * </pre>
     *
     * <code>.commonmodule.ASG VADisChaRteMaxRtg = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return The vADisChaRteMaxRtg.
     */
    public openfmb.commonmodule.ASG getVADisChaRteMaxRtg() {
      if (vADisChaRteMaxRtgBuilder_ == null) {
        return vADisChaRteMaxRtg_ == null ? openfmb.commonmodule.ASG.getDefaultInstance() : vADisChaRteMaxRtg_;
      } else {
        return vADisChaRteMaxRtgBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Apparent Power Discharge Maximum Rating
     * </pre>
     *
     * <code>.commonmodule.ASG VADisChaRteMaxRtg = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setVADisChaRteMaxRtg(openfmb.commonmodule.ASG value) {
      if (vADisChaRteMaxRtgBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        vADisChaRteMaxRtg_ = value;
      } else {
        vADisChaRteMaxRtgBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Apparent Power Discharge Maximum Rating
     * </pre>
     *
     * <code>.commonmodule.ASG VADisChaRteMaxRtg = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setVADisChaRteMaxRtg(
        openfmb.commonmodule.ASG.Builder builderForValue) {
      if (vADisChaRteMaxRtgBuilder_ == null) {
        vADisChaRteMaxRtg_ = builderForValue.build();
      } else {
        vADisChaRteMaxRtgBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Apparent Power Discharge Maximum Rating
     * </pre>
     *
     * <code>.commonmodule.ASG VADisChaRteMaxRtg = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder mergeVADisChaRteMaxRtg(openfmb.commonmodule.ASG value) {
      if (vADisChaRteMaxRtgBuilder_ == null) {
        if (((bitField0_ & 0x00000004) != 0) &&
          vADisChaRteMaxRtg_ != null &&
          vADisChaRteMaxRtg_ != openfmb.commonmodule.ASG.getDefaultInstance()) {
          getVADisChaRteMaxRtgBuilder().mergeFrom(value);
        } else {
          vADisChaRteMaxRtg_ = value;
        }
      } else {
        vADisChaRteMaxRtgBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Apparent Power Discharge Maximum Rating
     * </pre>
     *
     * <code>.commonmodule.ASG VADisChaRteMaxRtg = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder clearVADisChaRteMaxRtg() {
      bitField0_ = (bitField0_ & ~0x00000004);
      vADisChaRteMaxRtg_ = null;
      if (vADisChaRteMaxRtgBuilder_ != null) {
        vADisChaRteMaxRtgBuilder_.dispose();
        vADisChaRteMaxRtgBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Apparent Power Discharge Maximum Rating
     * </pre>
     *
     * <code>.commonmodule.ASG VADisChaRteMaxRtg = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.commonmodule.ASG.Builder getVADisChaRteMaxRtgBuilder() {
      bitField0_ |= 0x00000004;
      onChanged();
      return getVADisChaRteMaxRtgFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Apparent Power Discharge Maximum Rating
     * </pre>
     *
     * <code>.commonmodule.ASG VADisChaRteMaxRtg = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.commonmodule.ASGOrBuilder getVADisChaRteMaxRtgOrBuilder() {
      if (vADisChaRteMaxRtgBuilder_ != null) {
        return vADisChaRteMaxRtgBuilder_.getMessageOrBuilder();
      } else {
        return vADisChaRteMaxRtg_ == null ?
            openfmb.commonmodule.ASG.getDefaultInstance() : vADisChaRteMaxRtg_;
      }
    }
    /**
     * <pre>
     * Apparent Power Discharge Maximum Rating
     * </pre>
     *
     * <code>.commonmodule.ASG VADisChaRteMaxRtg = 3 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ASG, openfmb.commonmodule.ASG.Builder, openfmb.commonmodule.ASGOrBuilder> 
        getVADisChaRteMaxRtgFieldBuilder() {
      if (vADisChaRteMaxRtgBuilder_ == null) {
        vADisChaRteMaxRtgBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.ASG, openfmb.commonmodule.ASG.Builder, openfmb.commonmodule.ASGOrBuilder>(
                getVADisChaRteMaxRtg(),
                getParentForChildren(),
                isClean());
        vADisChaRteMaxRtg_ = null;
      }
      return vADisChaRteMaxRtgBuilder_;
    }

    private openfmb.commonmodule.ASG wChaRteMaxRtg_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ASG, openfmb.commonmodule.ASG.Builder, openfmb.commonmodule.ASGOrBuilder> wChaRteMaxRtgBuilder_;
    /**
     * <pre>
     * Active Power Charge Maximum Rating
     * </pre>
     *
     * <code>.commonmodule.ASG WChaRteMaxRtg = 4 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return Whether the wChaRteMaxRtg field is set.
     */
    public boolean hasWChaRteMaxRtg() {
      return ((bitField0_ & 0x00000008) != 0);
    }
    /**
     * <pre>
     * Active Power Charge Maximum Rating
     * </pre>
     *
     * <code>.commonmodule.ASG WChaRteMaxRtg = 4 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return The wChaRteMaxRtg.
     */
    public openfmb.commonmodule.ASG getWChaRteMaxRtg() {
      if (wChaRteMaxRtgBuilder_ == null) {
        return wChaRteMaxRtg_ == null ? openfmb.commonmodule.ASG.getDefaultInstance() : wChaRteMaxRtg_;
      } else {
        return wChaRteMaxRtgBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Active Power Charge Maximum Rating
     * </pre>
     *
     * <code>.commonmodule.ASG WChaRteMaxRtg = 4 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setWChaRteMaxRtg(openfmb.commonmodule.ASG value) {
      if (wChaRteMaxRtgBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        wChaRteMaxRtg_ = value;
      } else {
        wChaRteMaxRtgBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Active Power Charge Maximum Rating
     * </pre>
     *
     * <code>.commonmodule.ASG WChaRteMaxRtg = 4 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setWChaRteMaxRtg(
        openfmb.commonmodule.ASG.Builder builderForValue) {
      if (wChaRteMaxRtgBuilder_ == null) {
        wChaRteMaxRtg_ = builderForValue.build();
      } else {
        wChaRteMaxRtgBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Active Power Charge Maximum Rating
     * </pre>
     *
     * <code>.commonmodule.ASG WChaRteMaxRtg = 4 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder mergeWChaRteMaxRtg(openfmb.commonmodule.ASG value) {
      if (wChaRteMaxRtgBuilder_ == null) {
        if (((bitField0_ & 0x00000008) != 0) &&
          wChaRteMaxRtg_ != null &&
          wChaRteMaxRtg_ != openfmb.commonmodule.ASG.getDefaultInstance()) {
          getWChaRteMaxRtgBuilder().mergeFrom(value);
        } else {
          wChaRteMaxRtg_ = value;
        }
      } else {
        wChaRteMaxRtgBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Active Power Charge Maximum Rating
     * </pre>
     *
     * <code>.commonmodule.ASG WChaRteMaxRtg = 4 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder clearWChaRteMaxRtg() {
      bitField0_ = (bitField0_ & ~0x00000008);
      wChaRteMaxRtg_ = null;
      if (wChaRteMaxRtgBuilder_ != null) {
        wChaRteMaxRtgBuilder_.dispose();
        wChaRteMaxRtgBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Active Power Charge Maximum Rating
     * </pre>
     *
     * <code>.commonmodule.ASG WChaRteMaxRtg = 4 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.commonmodule.ASG.Builder getWChaRteMaxRtgBuilder() {
      bitField0_ |= 0x00000008;
      onChanged();
      return getWChaRteMaxRtgFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Active Power Charge Maximum Rating
     * </pre>
     *
     * <code>.commonmodule.ASG WChaRteMaxRtg = 4 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.commonmodule.ASGOrBuilder getWChaRteMaxRtgOrBuilder() {
      if (wChaRteMaxRtgBuilder_ != null) {
        return wChaRteMaxRtgBuilder_.getMessageOrBuilder();
      } else {
        return wChaRteMaxRtg_ == null ?
            openfmb.commonmodule.ASG.getDefaultInstance() : wChaRteMaxRtg_;
      }
    }
    /**
     * <pre>
     * Active Power Charge Maximum Rating
     * </pre>
     *
     * <code>.commonmodule.ASG WChaRteMaxRtg = 4 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ASG, openfmb.commonmodule.ASG.Builder, openfmb.commonmodule.ASGOrBuilder> 
        getWChaRteMaxRtgFieldBuilder() {
      if (wChaRteMaxRtgBuilder_ == null) {
        wChaRteMaxRtgBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.ASG, openfmb.commonmodule.ASG.Builder, openfmb.commonmodule.ASGOrBuilder>(
                getWChaRteMaxRtg(),
                getParentForChildren(),
                isClean());
        wChaRteMaxRtg_ = null;
      }
      return wChaRteMaxRtgBuilder_;
    }

    private openfmb.commonmodule.ASG wDisChaRteMaxRtg_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ASG, openfmb.commonmodule.ASG.Builder, openfmb.commonmodule.ASGOrBuilder> wDisChaRteMaxRtgBuilder_;
    /**
     * <pre>
     * Active Power Discharge Maximum Rating
     * </pre>
     *
     * <code>.commonmodule.ASG WDisChaRteMaxRtg = 5 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return Whether the wDisChaRteMaxRtg field is set.
     */
    public boolean hasWDisChaRteMaxRtg() {
      return ((bitField0_ & 0x00000010) != 0);
    }
    /**
     * <pre>
     * Active Power Discharge Maximum Rating
     * </pre>
     *
     * <code>.commonmodule.ASG WDisChaRteMaxRtg = 5 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return The wDisChaRteMaxRtg.
     */
    public openfmb.commonmodule.ASG getWDisChaRteMaxRtg() {
      if (wDisChaRteMaxRtgBuilder_ == null) {
        return wDisChaRteMaxRtg_ == null ? openfmb.commonmodule.ASG.getDefaultInstance() : wDisChaRteMaxRtg_;
      } else {
        return wDisChaRteMaxRtgBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Active Power Discharge Maximum Rating
     * </pre>
     *
     * <code>.commonmodule.ASG WDisChaRteMaxRtg = 5 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setWDisChaRteMaxRtg(openfmb.commonmodule.ASG value) {
      if (wDisChaRteMaxRtgBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        wDisChaRteMaxRtg_ = value;
      } else {
        wDisChaRteMaxRtgBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000010;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Active Power Discharge Maximum Rating
     * </pre>
     *
     * <code>.commonmodule.ASG WDisChaRteMaxRtg = 5 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setWDisChaRteMaxRtg(
        openfmb.commonmodule.ASG.Builder builderForValue) {
      if (wDisChaRteMaxRtgBuilder_ == null) {
        wDisChaRteMaxRtg_ = builderForValue.build();
      } else {
        wDisChaRteMaxRtgBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000010;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Active Power Discharge Maximum Rating
     * </pre>
     *
     * <code>.commonmodule.ASG WDisChaRteMaxRtg = 5 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder mergeWDisChaRteMaxRtg(openfmb.commonmodule.ASG value) {
      if (wDisChaRteMaxRtgBuilder_ == null) {
        if (((bitField0_ & 0x00000010) != 0) &&
          wDisChaRteMaxRtg_ != null &&
          wDisChaRteMaxRtg_ != openfmb.commonmodule.ASG.getDefaultInstance()) {
          getWDisChaRteMaxRtgBuilder().mergeFrom(value);
        } else {
          wDisChaRteMaxRtg_ = value;
        }
      } else {
        wDisChaRteMaxRtgBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000010;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Active Power Discharge Maximum Rating
     * </pre>
     *
     * <code>.commonmodule.ASG WDisChaRteMaxRtg = 5 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder clearWDisChaRteMaxRtg() {
      bitField0_ = (bitField0_ & ~0x00000010);
      wDisChaRteMaxRtg_ = null;
      if (wDisChaRteMaxRtgBuilder_ != null) {
        wDisChaRteMaxRtgBuilder_.dispose();
        wDisChaRteMaxRtgBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Active Power Discharge Maximum Rating
     * </pre>
     *
     * <code>.commonmodule.ASG WDisChaRteMaxRtg = 5 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.commonmodule.ASG.Builder getWDisChaRteMaxRtgBuilder() {
      bitField0_ |= 0x00000010;
      onChanged();
      return getWDisChaRteMaxRtgFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Active Power Discharge Maximum Rating
     * </pre>
     *
     * <code>.commonmodule.ASG WDisChaRteMaxRtg = 5 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.commonmodule.ASGOrBuilder getWDisChaRteMaxRtgOrBuilder() {
      if (wDisChaRteMaxRtgBuilder_ != null) {
        return wDisChaRteMaxRtgBuilder_.getMessageOrBuilder();
      } else {
        return wDisChaRteMaxRtg_ == null ?
            openfmb.commonmodule.ASG.getDefaultInstance() : wDisChaRteMaxRtg_;
      }
    }
    /**
     * <pre>
     * Active Power Discharge Maximum Rating
     * </pre>
     *
     * <code>.commonmodule.ASG WDisChaRteMaxRtg = 5 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ASG, openfmb.commonmodule.ASG.Builder, openfmb.commonmodule.ASGOrBuilder> 
        getWDisChaRteMaxRtgFieldBuilder() {
      if (wDisChaRteMaxRtgBuilder_ == null) {
        wDisChaRteMaxRtgBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.ASG, openfmb.commonmodule.ASG.Builder, openfmb.commonmodule.ASGOrBuilder>(
                getWDisChaRteMaxRtg(),
                getParentForChildren(),
                isClean());
        wDisChaRteMaxRtg_ = null;
      }
      return wDisChaRteMaxRtgBuilder_;
    }

    private openfmb.commonmodule.ASG wHRtg_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ASG, openfmb.commonmodule.ASG.Builder, openfmb.commonmodule.ASGOrBuilder> wHRtgBuilder_;
    /**
     * <pre>
     * Energy rating of the DER storage.
     * </pre>
     *
     * <code>.commonmodule.ASG WHRtg = 6 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return Whether the wHRtg field is set.
     */
    public boolean hasWHRtg() {
      return ((bitField0_ & 0x00000020) != 0);
    }
    /**
     * <pre>
     * Energy rating of the DER storage.
     * </pre>
     *
     * <code>.commonmodule.ASG WHRtg = 6 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return The wHRtg.
     */
    public openfmb.commonmodule.ASG getWHRtg() {
      if (wHRtgBuilder_ == null) {
        return wHRtg_ == null ? openfmb.commonmodule.ASG.getDefaultInstance() : wHRtg_;
      } else {
        return wHRtgBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Energy rating of the DER storage.
     * </pre>
     *
     * <code>.commonmodule.ASG WHRtg = 6 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setWHRtg(openfmb.commonmodule.ASG value) {
      if (wHRtgBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        wHRtg_ = value;
      } else {
        wHRtgBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000020;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Energy rating of the DER storage.
     * </pre>
     *
     * <code>.commonmodule.ASG WHRtg = 6 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setWHRtg(
        openfmb.commonmodule.ASG.Builder builderForValue) {
      if (wHRtgBuilder_ == null) {
        wHRtg_ = builderForValue.build();
      } else {
        wHRtgBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000020;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Energy rating of the DER storage.
     * </pre>
     *
     * <code>.commonmodule.ASG WHRtg = 6 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder mergeWHRtg(openfmb.commonmodule.ASG value) {
      if (wHRtgBuilder_ == null) {
        if (((bitField0_ & 0x00000020) != 0) &&
          wHRtg_ != null &&
          wHRtg_ != openfmb.commonmodule.ASG.getDefaultInstance()) {
          getWHRtgBuilder().mergeFrom(value);
        } else {
          wHRtg_ = value;
        }
      } else {
        wHRtgBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000020;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Energy rating of the DER storage.
     * </pre>
     *
     * <code>.commonmodule.ASG WHRtg = 6 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder clearWHRtg() {
      bitField0_ = (bitField0_ & ~0x00000020);
      wHRtg_ = null;
      if (wHRtgBuilder_ != null) {
        wHRtgBuilder_.dispose();
        wHRtgBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Energy rating of the DER storage.
     * </pre>
     *
     * <code>.commonmodule.ASG WHRtg = 6 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.commonmodule.ASG.Builder getWHRtgBuilder() {
      bitField0_ |= 0x00000020;
      onChanged();
      return getWHRtgFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Energy rating of the DER storage.
     * </pre>
     *
     * <code>.commonmodule.ASG WHRtg = 6 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.commonmodule.ASGOrBuilder getWHRtgOrBuilder() {
      if (wHRtgBuilder_ != null) {
        return wHRtgBuilder_.getMessageOrBuilder();
      } else {
        return wHRtg_ == null ?
            openfmb.commonmodule.ASG.getDefaultInstance() : wHRtg_;
      }
    }
    /**
     * <pre>
     * Energy rating of the DER storage.
     * </pre>
     *
     * <code>.commonmodule.ASG WHRtg = 6 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.ASG, openfmb.commonmodule.ASG.Builder, openfmb.commonmodule.ASGOrBuilder> 
        getWHRtgFieldBuilder() {
      if (wHRtgBuilder_ == null) {
        wHRtgBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.ASG, openfmb.commonmodule.ASG.Builder, openfmb.commonmodule.ASGOrBuilder>(
                getWHRtg(),
                getParentForChildren(),
                isClean());
        wHRtg_ = null;
      }
      return wHRtgBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:essmodule.ESSCapabilityRatings)
  }

  // @@protoc_insertion_point(class_scope:essmodule.ESSCapabilityRatings)
  private static final openfmb.essmodule.ESSCapabilityRatings DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.essmodule.ESSCapabilityRatings();
  }

  public static openfmb.essmodule.ESSCapabilityRatings getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<ESSCapabilityRatings>
      PARSER = new com.google.protobuf.AbstractParser<ESSCapabilityRatings>() {
    @java.lang.Override
    public ESSCapabilityRatings parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<ESSCapabilityRatings> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<ESSCapabilityRatings> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.essmodule.ESSCapabilityRatings getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

